{------------------------------------------------------------------------------

Copyright (C) 2002  Rainer Queck
e-mail: Rainer.Queck@Qutronic.de
http://www.qutronic.de


This code is free; you can redistribute it and/or
modify it under the terms of the MPL MOZILLA PUBLIC LICENSE. 

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
MPL MOZILLA PUBLIC LICENSE for more details at http://www.mozilla.org/MPL

//---------------------------------------------------------------------------}
// Unit Created at    : somewhen in 2002
// Unit last modified : Date: 21.12.2002  Time :10:13:30
//------------------------------------------------------------------------------
unit QMMDExp;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  ToolsApi,MailboxRq;

type
  TWizardBase = class;
  TWizardBase = class (TInterfacedObject, IOTANotifier)
    procedure AfterSave;
    procedure BeforeSave;
    procedure Destroyed;
    procedure Modified;
  end;
  
  TQMMDEWizard = class (TWizardBase, IOTAWizard, IOTAMenuWizard)
    procedure Execute; virtual;
    function GetIDString: string; virtual;
    function GetMenuText: string; virtual;
    function GetName: string; virtual;
    function GetState: TWizardState; virtual;
  private
    procedure CallStackToMM(aStrList : TStringList);
    procedure OnMbError(Sender : TObject ; Error : TMailBoxErrors);
  end;
  

procedure Register;

implementation

procedure Register;
begin
  RegisterPackageWizard(TQMMDEWizard.Create as IOTAWizard);
end;

{
********************************* TWizardBase **********************************
}
procedure TWizardBase.AfterSave;
begin
  
end;

procedure TWizardBase.BeforeSave;
begin
  
end;

procedure TWizardBase.Destroyed;
begin
  
end;

procedure TWizardBase.Modified;
begin
  
end;

{
********************************* TQMMDEWizard *********************************
}
procedure TQMMDEWizard.CallStackToMM(aStrList : TStringList);
var
  aStream: TMemoryStream;
begin
  with TRqMailBox.Create(True) do
  begin
    OnError:=OnMbError;
    Receiver:='MbQMME';
    if not ReceiverAvailable then
    begin
      ShowMessage('Qutronics Modelmaker Expert can not receive!');
      Free;
      exit;
    end;
    aStream:=TMemoryStream.Create;
    try
      aStrList.SaveToStream(aStream);
      aStrList.SaveToFile('C:\Temp\CallStackDelphi.txt');
      aStream.Position:=0;
      Send(aStream);
    finally
      aStream.Free;
      Free;
    end;
  end;
end;

procedure TQMMDEWizard.Execute;
var
  CallCount: Integer;
  aProcess: IOTAProcess;
  i: Integer;
  dbgServices: IOTADebuggerServices;
  aThread: IOTAThread;
  aStrList: TStringList;
  k: Integer;
  aStr: string;
  info: TStringList;
begin
  info:=TStringList.Create;
  dbgServices:=BorlandIDEServices as IOTADebuggerServices;
  info.add('ProcessCount:'+IntToStr(dbgServices.ProcessCount));
  for i:=0 to dbgServices.ProcessCount-1 do
  begin
    aProcess:=dbgServices.Processes[i];
    info.add('dbgServices.Processes['+IntToStr(i)+'].ThreadCount='+IntToStr(aProcess.ThreadCount));
    aThread:=aProcess.GetCurrentThread;
    CallCount:=aThread.GetCallCount;
    info.add('CallCount='+IntToStr(CallCount));
    if CallCount>1 then
    begin
      aStrList:=TStringList.Create;
        try
          for k:=1 to CallCount do
          begin
            aStr:=aThread.CallHeaders[k];
            aStrList.Add(aStr);
          end;
          CallStackToMM(aStrList);
        finally
          aStrList.Free;
        end;
    end;
  end;
  info.SaveToFile('C:\temp\info.txt');
  info.Free;
end;

function TQMMDEWizard.GetIDString: string;
begin
  Result := 'Qutronic''s interface wizzard MM<->Delphi';
end;

function TQMMDEWizard.GetMenuText: string;
begin
  Result:='Call Stack -> Modelmaker';
end;

function TQMMDEWizard.GetName: string;
begin
  Result := 'Qutronics CallStack Sequence diagram generation';
end;

function TQMMDEWizard.GetState: TWizardState;
begin
  Result := [wsEnabled];
end;

procedure TQMMDEWizard.OnMbError(Sender : TObject ; Error : TMailBoxErrors);
begin
end;


end.
