//------------------------------------------------------------------------------
// This software was written by Qutronic E. Queck
// It may be use as it is. Don't complain any things it does or does not do
// to the autor.
// However sugestions are wellcome and might be considered on future Versions.
//
// Author : Rainer Queck
//          Rainer.Queck@t-online.de
//
//------------------------------------------------------------------------------
// Unit Created at    : Date: 16.02.02  Time :12:56:40
// Unit last modified : Date: 21.12.2002  Time :07:47:23
//------------------------------------------------------------------------------
unit QutronicBaseExpert;

interface

uses  SysUtils,Windows,Classes,Menus,Forms,Dialogs,
      MMToolsApi;

type
  TMMBaseExpert = class (TInterfacedObject, IUnknown, IMMExpert)
  protected
    function GetMenuPositions(Index: Integer): TMMMenuPosition; virtual; 
            safecall;
    function GetMenuShortCuts(Index: Integer): TShortCut; virtual; safecall;
    function GetVerbCount: Integer; virtual; safecall;
    function GetVerbs(Index: Integer): WideString; virtual; safecall;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Destroyed; safecall;
    procedure Execute(Index: Integer); virtual; safecall;
    function ExpertID: WideString; virtual; safecall;
    property MenuPositions[Index: Integer]: TMMMenuPosition read 
            GetMenuPositions;
    property MenuShortCuts[Index: Integer]: TShortCut read GetMenuShortCuts;
    property VerbCount: Integer read GetVerbCount;
    property Verbs[Index: Integer]: WideString read GetVerbs;
  end;
  
implementation

{
******************************** TMMBaseExpert *********************************
}
constructor TMMBaseExpert.Create;
begin
  inherited Create;
end;

destructor TMMBaseExpert.Destroy;
begin
  inherited Destroy;
end;

procedure TMMBaseExpert.Destroyed;
begin
  // Just before ModelMaker releases the expert the Desoyed method is called.
  // Drop all references to the expert here.
  // DemoForm.Free;
end;

procedure TMMBaseExpert.Execute(Index: Integer);
begin
  // the menu item was clicked: perform associated action here
  case TMMMenuPosition(Index) of
    mpToolsMenu           : MessageDlg('ToolsMenu aufgerufen....', mtInformation, [mbOK], 0);
    mpHelpMenu            : MessageDlg('MainMenu aufgerufen....', mtInformation, [mbOK], 0);
    mpVCSMenu             : MessageDlg('VCSMenu aufgerufen....', mtInformation, [mbOK], 0);
    mpClassesMenu         : MessageDlg('ClassesMenu aufgerufen....', mtInformation, [mbOK], 0);
    mpMembersMenu         : MessageDlg('MembersMenu aufgerufen....', mtInformation, [mbOK], 0);
    mpUnitsMenu           : MessageDlg('UnitsMenu aufgerufen....', mtInformation, [mbOK], 0);
    mpDiagramMenu         : MessageDlg('DiagramMenu aufgerufen....', mtInformation, [mbOK], 0);
    mpDiagramEditorMenu   : MessageDlg('DiagramEditorMenu aufgerufen....', mtInformation, [mbOK], 0);
  //   if not Assigned(DemoForm) then
  //     DemoForm := TDemoForm.Create(Application);
  //   DemoForm.ShowModal;
  else
    MessageBox(0, PChar('ExecuteVerb = ' + IntToStr(Index)), nil, 0);
  end;
end;

function TMMBaseExpert.ExpertID: WideString;
begin
  Result := 'RQBaseExpert';
end;

function TMMBaseExpert.GetMenuPositions(Index: Integer): TMMMenuPosition;
begin
  // Define to which ModelMaker sub-menu should each verb be added
  {
  mpToolsMenu, mpHelpMenu, mpVCSMenu, mpClassesMenu,
  mpMembersMenu, mpUnitsMenu, mpDiagramMenu, mpDiagramEditorMenu
  }
  
  case Index of
    0: Result := mpToolsMenu;
    1: Result := mpHelpMenu;
    2: Result := mpVCSMenu;
    3: Result := mpClassesMenu;
    4: Result := mpMembersMenu;
    5: Result := mpUnitsMenu;
    6: Result := mpDiagramMenu;
    7: Result := mpDiagramEditorMenu;
  else
   begin
     Assert(False);
   end;
  end;
end;

function TMMBaseExpert.GetMenuShortCuts(Index: Integer): TShortCut;
begin
  // Return a shortcut for each menu item, since we have only one verb it's not .
  // dependent on Index
  case Index of
    0: Result := ShortCut(Ord('D'), [ssCtrl, ssShift]);
    1: Result := ShortCut(Ord('E'), [ssCtrl, ssShift]);
    2: Result := ShortCut(Ord('F'), [ssCtrl, ssShift]);
    3: Result := ShortCut(Ord('G'), [ssCtrl, ssShift]);
    4: Result := ShortCut(Ord('H'), [ssCtrl, ssShift]);
    5: Result := ShortCut(Ord('I'), [ssCtrl, ssShift]);
    6: Result := ShortCut(Ord('J'), [ssCtrl, ssShift]);
    7: Result := ShortCut(Ord('K'), [ssCtrl, ssShift]);
  else
   begin
     Assert(False);
     Result := ShortCut(Ord('D'), [ssCtrl, ssShift]);
   end;
  end;
end;

function TMMBaseExpert.GetVerbCount: Integer;
begin
  // Just one menu item to be inserted
  Result := 8;
end;

function TMMBaseExpert.GetVerbs(Index: Integer): WideString;
begin
  // Return menu items Captions here
  case Index of
    0: Result := 'MM Basis Expert im Toolsmenu';
    1: Result := 'MM Basis Expert im MainMenu';
    2: Result := 'MM Basis Expert im VCSMenu';
    3: Result := 'MM Basis Expert im ClassesMenu';
    4: Result := 'MM Basis Expert im MembersMenu';
    5: Result := 'MM Basis Expert im UnitsMenu';
    6: Result := 'MM Basis Expert im DiagramMenu';
    7: Result := 'MM Basis Expert im DiagramEditorMenu';
  else
   begin
     Assert(False);
     Result := '';
   end;
  end;
end;

end.
